*** old-NetBSD/src/sys/arch/amiga/dev/zbus.c
--- NetBSD/src/sys/arch/amiga/dev/zbus.c
***************
*** 110,115 ****
--- 110,116 ----
  	{ "grfcl",	2193,	1},	/* Spectrum regs */
  	{ "grfcl",	2195,	5},	/* Piccolo mem */
  	{ "grfcl",	2195,	6},	/* Piccolo regs */
+ 
  	/* MacroSystemsUS */
  	{ "wesc",	2203,	19},	/* Warp engine */
  	/* phase 5 digital products? */
***************
*** 118,133 ****
  	/* Commodore Amiga */
  	{ "afsc",	514,	84},	/* A4091 SCSI HD Controller */
  	/* Hacker Inc. */
! 	{ "mlhsc",	2011,	1 }
  };
  static int naconfent = sizeof(aconftab) / sizeof(struct aconfdata);
  
  /*
   * Anything listed in this table is subject to pre-configuration,
   * if autoconf.c:config_console() calls amiga_config_found() on
!  * the Zorro III device.
   */
  static struct preconfdata preconftab[] = {
  	{ 18260, 6, 0 },
  	/* Retina BLT Z3 */
  	{ 18260, 16, 0},
--- 119,138 ----
  	/* Commodore Amiga */
  	{ "afsc",	514,	84},	/* A4091 SCSI HD Controller */
  	/* Hacker Inc. */
! 	{ "mlhsc",	2011,	1 },		/* Michael Hitch */
! 	{ "cross",	2011,	3 },		/* Mark Tomlinsen */
! 	/* David Salamon */
! 	{ "ggbus",	2150,	1 }
  };
  static int naconfent = sizeof(aconftab) / sizeof(struct aconfdata);
  
  /*
   * Anything listed in this table is subject to pre-configuration,
   * if autoconf.c:config_console() calls amiga_config_found() on
!  * the zbus device.
   */
  static struct preconfdata preconftab[] = {
+ 	/* Retina BLT Z2 */
  	{ 18260, 6, 0 },
  	/* Retina BLT Z3 */
  	{ 18260, 16, 0},
*** old-NetBSD/src/sys/arch/amiga/dev/zssc.c
--- NetBSD/src/sys/arch/amiga/dev/zssc.c
***************
*** 79,85 ****
  	DV_DULL, sizeof(struct siop_softc), NULL, 0 };
  
  /*
!  * if we are an PPI Zeus
   */
  int
  zsscmatch(pdp, cdp, auxp)
--- 79,85 ----
  	DV_DULL, sizeof(struct siop_softc), NULL, 0 };
  
  /*
!  * if we are a PPI Zeus
   */
  int
  zsscmatch(pdp, cdp, auxp)
***************
*** 130,135 ****
--- 130,136 ----
  	sc->sc_isr.isr_intr = zssc_dmaintr;
  	sc->sc_isr.isr_arg = sc;
  	sc->sc_isr.isr_ipl = 6;
+ 	sc->sc_isr.isr_mapped_ipl = 3;
  	add_isr(&sc->sc_isr);
  
  	/*
*** old-NetBSD/src/sys/arch/amiga/include/mtpr.h
--- NetBSD/src/sys/arch/amiga/include/mtpr.h
***************
*** 41,48 ****
   *
   *	@(#)mtpr.h	7.2 (Berkeley) 11/3/90
   */
! #ifndef _MACHINE_MPTR_H_
! #define _MACHINE_MPTR_H_
  
  #ifdef _KERNEL
  /*
--- 41,48 ----
   *
   *	@(#)mtpr.h	7.2 (Berkeley) 11/3/90
   */
! #ifndef _MACHINE_MTPR_H_
! #define _MACHINE_MTPR_H_
  
  #ifdef _KERNEL
  /*
***************
*** 60,66 ****
  
  #define SIR_NET		0x1	/* call netintr */
  #define SIR_CLOCK	0x2	/* call softclock */
! #define	SIR_CBACK	0x4	/* walk the sicallback-chain */
  
  #define siroff(x)	ssir &= ~(x)
  #define setsoftint()	(custom.intreq = INTF_SETCLR|INTF_SOFTINT)
--- 60,66 ----
  
  #define SIR_NET		0x1	/* call netintr */
  #define SIR_CLOCK	0x2	/* call softclock */
! #define SIR_CBACK	0x4	/* walk the sicallback-chain */
  
  #define siroff(x)	ssir &= ~(x)
  #define setsoftint()	(custom.intreq = INTF_SETCLR|INTF_SOFTINT)
***************
*** 68,74 ****
  #define setsoftnet()	(ssir |= SIR_NET, setsoftint())
  #define setsoftclock()	(ssir |= SIR_CLOCK, setsoftint())
  #define setsoftcback()	(ssir |= SIR_CBACK, setsoftint())
- 
  #endif /* _KERNEL */
  
! #endif /* !_MACHINE_MPTR_H_ */
--- 68,73 ----
  #define setsoftnet()	(ssir |= SIR_NET, setsoftint())
  #define setsoftclock()	(ssir |= SIR_CLOCK, setsoftint())
  #define setsoftcback()	(ssir |= SIR_CBACK, setsoftint())
  #endif /* _KERNEL */
  
! #endif /* !_MACHINE_MTPR_H_ */
*** old-NetBSD/src/sys/arch/amiga/include/param.h
--- NetBSD/src/sys/arch/amiga/include/param.h
***************
*** 149,200 ****
   */
  #include <machine/psl.h>
  
! /*
!  * point to the custom.intenar and custom.intenaw respectively.
!  */
! extern volatile unsigned short *amiga_intena_read, *amiga_intena_write;
  
! #if 0
! #define _debug_spl(s) \
  ({ \
          register int _spl_r; \
  \
!         __asm __volatile ("clrl %0; movew sr,%0; movew %1,sr" : \
!                 "&=d" (_spl_r) : "di" (s)); \
! 	if ((_spl_r&PSL_IPL) > ((s)&PSL_IPL)&&((s)&PSL_IPL)!=PSL_IPL1) \
! 		printf ("%s:%d:spl(%d) ==> spl(%d)!!\n",__FILE__,__LINE__, \
! 		    ((PSL_IPL&_spl_r)>>8), ((PSL_IPL&(s))>>8)); \
          _spl_r; \
  })
! #else
! /*
!  * Don't lower IPL below current IPL (unless new IPL is 6)
!  */
! #define _debug_spl(s) \
  ({ \
          register int _spl_r; \
  \
!         __asm __volatile ("clrl %0; movew sr,%0" : \
!                 "&=d" (_spl_r)); \
! 	if ((((s)&PSL_IPL) >= PSL_IPL6) || (_spl_r&PSL_IPL) < ((s)&PSL_IPL) || ((s)&PSL_IPL) <= PSL_IPL1) \
! 		__asm __volatile ("movew %0,sr" : : "di" (s)); \
          _spl_r; \
  })
  #endif
  
  #define _spl_no_check(s) \
  ({ \
          register int _spl_r; \
  \
!         __asm __volatile ("clrl %0; movew sr,%0; movew %1,sr" : \
!                 "&=d" (_spl_r) : "di" (s)); \
!         _spl_r; \
  })
! #if defined (DEBUGXX)		/* No workee */
! #define _spl _debug_spl
! #else
! #define _spl _spl_no_check
! #endif
  
  #define spl0()	_spl(PSL_S|PSL_IPL0)
  #define spl1()	_spl(PSL_S|PSL_IPL1)
--- 149,241 ----
   */
  #include <machine/psl.h>
  
! #ifdef SPL_PROF
  
! struct _spl_ent {
! 	int	psw;
! 	int	ticks;
! 	int	usec;
! };
! 
! #define _spl_push(s) \
  ({ \
          register int _spl_r; \
  \
! 	__asm __volatile("clrl %0; movew sr,%0" : "=d" (_spl_r)); \
! 	if (spl_prof || spl_debug) { \
! 		if (spl_debug && (_spl_r & PSL_IPL) > (s & PSL_IPL)) \
! 			printf ("%s:%d: unexpected lowering of spl" \
! 			    " 0x%x to 0x%x\n", \
! 		    	    __FILE__, __LINE__, _spl_r, s); \
!         	_spl_p->psw = _spl_r; \
! 		if (spl_prof) { \
! 	        	_spl_p->ticks = ticks; \
!         		_spl_p->usec = clkread(); \
! 		} \
!         	_spl_p++; \
! 	} \
! 	if ((isr_exter_ipl << 8) > (s & PSL_IPL)) \
! 		walk_ipls(isr_exter_ipl, s); \
!         __asm __volatile("movew %0,sr" : : "di" (s)); \
          _spl_r; \
  })
! 
! #define _spl_pop(s) \
  ({ \
+ 	u_int elapsed; \
          register int _spl_r; \
  \
!         __asm __volatile("clrl %0; movew sr,%0" : "=d" (_spl_r)); \
! 	if ((spl_prof || spl_debug) && _spl_p > _spl_stack) { \
! 		_spl_p--; \
! 		if (_spl_p->psw != s) { \
! 			if (spl_debug) \
! 				printf ("%s:%d: unexpected spl 0x%x " \
! 				    "(wanted 0x%x)\n", \
! 				    __FILE__, __LINE__, s, _spl_p->psw); \
! 			_spl_p++; \
! 		} else if (spl_prof) { \
!         		elapsed = 10000 * (ticks - _spl_p->ticks) + \
! 			    clkread() - _spl_p->usec; \
!         		if (elapsed > 100) \
! 				printf ( \
! 				    "%s:%d: long spl (%d us) above 0x%x\n", \
! 				    __FILE__, __LINE__, elapsed, s); \
! 		} \
! 	} \
! 	if ((isr_exter_ipl << 8) > (s & PSL_IPL)) \
! 		walk_ipls(isr_exter_ipl, s); \
!         __asm __volatile("movew %0,sr" : : "di" (s)); \
          _spl_r; \
  })
+ 
+ #define _spl	_spl_push
+ #define splx	_spl_pop
+ 
+ #ifdef _KERNEL
+ extern int ticks;
+ extern int clkread();
+ extern struct _spl_ent _spl_stack[], *_spl_p;
+ extern int spl_debug, spl_prof;
  #endif
  
+ #else /* SPL_PROF */
+ 
  #define _spl_no_check(s) \
  ({ \
          register int _spl_r; \
  \
!         __asm __volatile("clrl %0; movew sr,%0" : "=d" (_spl_r)); \
! 	if ((isr_exter_ipl << 8) > (s & PSL_IPL)) \
! 		walk_ipls(isr_exter_ipl, s); \
!         __asm __volatile("movew %0,sr" : : "di" (s)); \
! 	_spl_r; \
  })
! 
! #define _spl	_spl_no_check
! #define splx	_spl_no_check
! 
! #endif /* SPL_PROF */
  
  #define spl0()	_spl(PSL_S|PSL_IPL0)
  #define spl1()	_spl(PSL_S|PSL_IPL1)
***************
*** 226,236 ****
  #define splsched()	spl4()
  #endif
  
- #define splx(s)         _spl_no_check(s)
- 
  #ifdef _KERNEL
  void delay __P((int));
  void DELAY __P((int));
  #endif
  
  #endif /* !_MACHINE_PARAM_H_ */
--- 267,277 ----
  #define splsched()	spl4()
  #endif
  
  #ifdef _KERNEL
  void delay __P((int));
  void DELAY __P((int));
+ extern int isr_exter_ipl;
+ extern void walk_ipls __P((int, int));
  #endif
  
  #endif /* !_MACHINE_PARAM_H_ */
*** old-NetBSD/src/sys/arch/amiga/include/trap.h
--- NetBSD/src/sys/arch/amiga/include/trap.h
***************
*** 1,4 ****
! /*	$NetBSD: trap.h,v 1.8 1995/02/12 19:19:39 chopps Exp $	*/
  
  #ifndef _MACHINE_TRAP_H_
  #define _MACHINE_TRAP_H_
--- 1,4 ----
! /*	$NetBSD: trap.h,v 1.7 1994/10/26 02:06:42 cgd Exp $	*/
  
  #ifndef _MACHINE_TRAP_H_
  #define _MACHINE_TRAP_H_
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/ISA-HOWTO
***************
*** 0 ****
--- 1,29 ----
+ Move i386/isa/foo*.[ch] to amiga/isa possibly prepending 'isa' to the name
+ 
+ Reflect possible filename change in the source
+ 
+ Change include of i386/isa/isa_machdep.h to amiga/isa/isa_machdep.h
+ 
+ Move possible other i386/isa/*.h files that are needed
+ 
+ If there are inw, outw, insw or outsw think carefully if these are words
+ that should be converted to host order or not.  I.e. if you're reading
+ a device register holding a 16-bit flag word, you should convert it, but
+ if you're reading raw data word-wise you should not.  The functions to
+ do this are itohs for converting from isa to host order and htois for the
+ other way round.
+ 
+ Follow up if ia_maddr is used and change loads/stores to the suitable
+ ldb, stb, ldw and stw inlines defined in isabusvar.h.  Think about conversion
+ to host order for wordwide accesses.  If the driver uses bcopy for moves
+ from/to shared memory then there's two bcopy versions called copy_to_isa
+ and copy_from_isa for you to use instead.  These may have problems with
+ alignment if the target & source can reside on differently aligned areas,
+ i.e. target on odd address while source on even.  If you find such usages
+ please tell me.  bzero of shared memory is called zero_isa.  Tell me if you
+ need long versions of the load/store inlines.  Note that ia_maddr is a
+ virtual address in the i386 context, but not in our way of seeing it.  Thus
+ any kvtop calls can be removed.  I usually replace them with a cast to int.
+ 
+ For those of you writing isa drivers from scratch, look at another isa
+ driver as a template.
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/ISA-TODO
***************
*** 0 ****
--- 1,5 ----
+ LKM versions
+ 
+ Compile time option for using inline bridge-dependent code
+ 
+ 1.0 version
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/cross.c
***************
*** 0 ****
--- 1,422 ----
+ /*	$NetBSD: cross.c,v 1.0 1994/07/08 23:32:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1994 Niklas Hallqvist, Carsten Hammer
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Christian E. Hopps.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #include <sys/param.h>
+ #include <sys/device.h>
+ #include <sys/kernel.h>
+ #include <sys/malloc.h>
+ #include <sys/syslog.h>
+ #include <machine/cpu.h>
+ #include <amiga/amiga/custom.h>
+ #include <amiga/amiga/device.h>
+ #include <amiga/amiga/isr.h>
+ #include <amiga/dev/zbusvar.h>
+ #include <dev/isa/isavar.h>
+ #include <amiga/isa/isa_machdep.h>
+ #include <amiga/isa/crossvar.h>
+ #include <amiga/isa/crossreg.h>
+ 
+ int crossdebug = 0;
+ 
+ /* This static is OK because we only allow one ISA bus.  */
+ /* static */ struct cross_device *crossp;
+ 
+ void crossattach __P((struct device *, struct device *, void *));
+ int crossmatch __P((struct device *, void *, void *));
+ int crossprint __P((void *auxp, char *));
+ void crossoutb __P((struct device *, int, u_char));
+ u_char crossinb __P((struct device *, int));
+ void crossoutw __P((struct device *, int, u_short));
+ u_short crossinw __P((struct device *, int));
+ void crossstb __P((struct device *, int, u_char));
+ u_char crossldb __P((struct device *, int));
+ void crossstw __P((struct device *, int, u_short));
+ u_short crossldw __P((struct device *, int));
+ #if 0
+ void crossaddint __P((struct device *, int, int (*)(), void *,int));
+ void crossremint __P((struct device *, int));
+ #else
+ void crossaddint __P((int, int, struct intrhand *));
+ void crossremint __P((int));
+ #endif
+ 
+ struct cfdriver crosscd = {
+ 	NULL, "cross", crossmatch, crossattach, 
+ 	DV_DULL, sizeof(struct cross_device), 0
+ };
+ 
+ int
+ crossmatch(parent, match, aux)
+ 	struct device *parent;
+ 	void *match, *aux;
+ {
+ 	struct zbus_args *zap = aux;
+ 
+ 	/*
+ 	 * Check manufacturer and product id.
+ 	 */
+ 	if (zap->manid == 2011 && zap->prodid == 3)
+ 		return(1);
+ 	return(0);
+ }
+ 
+ void
+ crossattach(pdp, dp, auxp)
+ 	struct device *pdp, *dp;
+ 	void *auxp;
+ {
+ 	struct zbus_args *zap = auxp;
+ 	struct cross_device *cdp = (struct cross_device *)dp;
+ 
+ 	crossp = cdp;
+ 	bcopy(zap, &cdp->cd_zargs, sizeof(struct zbus_args));
+ 	cdp->cd_link.il_dev = dp;
+ 	cdp->cd_link.il_inb = crossinb;
+ 	cdp->cd_link.il_outb = crossoutb;
+ 	cdp->cd_link.il_inw = crossinw;
+ 	cdp->cd_link.il_outw = crossoutw;
+ 	cdp->cd_link.il_ldb = crossldb;
+ 	cdp->cd_link.il_stb = crossstb;
+ 	cdp->cd_link.il_ldw = crossldw;
+ 	cdp->cd_link.il_stw = crossstw;
+ 	cdp->cd_link.il_addint = crossaddint;
+ 	cdp->cd_link.il_remint = crossremint;
+ 	cdp->cd_imask = 1 << CROSS_MASTER;
+ 
+ 	/* Enable interrupts lazily in crossaddint.  */
+ 	CROSS_ENABLE_INTS(zap->va, 0);
+ 	/* Default 16 bit tranfer  */
+ 	*(volatile u_short *)(cdp->cd_zargs.va + CROSS_XLP_LATCH) = CROSS_SBHE; 
+ 
+ 	printf(": pa 0x%08x va 0x%08x size 0x%x\n", zap->pa, zap->va,
+             zap->size);
+ 
+ #if 0
+ 	cdp->cd_isr.isr_intr = crossintr6;
+ 	cdp->cd_isr.isr_ipl = 6;
+ 	cdp->cd_isr.isr_mapped_ipl = 4;
+ 	add_isr(&cdp->cd_isr);
+ #endif
+ 
+ 	/*
+ 	 * attempt to configure the board.
+ 	 */
+ 	config_found(dp, &cdp->cd_link, crossprint);
+ }
+ 
+ int
+ crossprint(auxp, pnp)
+ 	void *auxp;
+ 	char *pnp;
+ {
+ 	if (pnp == NULL)
+ 		return(QUIET);
+ 	return(UNCONF);
+ }
+ 
+ #if 0
+ /* XXX We don't care about the priority yet, although we ought to.  */
+ int
+ crossintr6()
+ {
+ 	struct cross_device *dev = crossp;
+ 	int ints;
+ 	int mine = 0;
+ 	int i;
+ 	int bit;
+ 
+ 	if (!crossp)
+ 		return 0;
+ 
+ 	ints = CROSS_GET_INT_STATUS(dev->cd_zargs.va) & dev->cd_imask;
+ 	while (ints) {
+ 		for (i = 0; bit = ffs(ints); ints >>= bit, i++) {
+ 			i += bit - 1;
+ 			if (!dev->cd_ifunc[i]) {
+ 				log(LOG_WARNING,
+ 				    "Huh, cd_ifunc[%d] was zero (ints=0x%04x, mask=0x%04x)\n",
+ 				    i, ints, dev->cd_imask);
+ #ifdef DDB
+ 				/*
+ 				 * We better try to find out how this
+ 				 * happened
+ 				 */
+ 				Debugger();
+ #endif
+ 			} else {
+ 				(*dev->cd_ifunc[i])(dev->cd_iarg[i]);
+ 				mine = 1;
+ 			}
+ 		}
+ 		ints = CROSS_GET_INT_STATUS(dev->cd_zargs.va) & dev->cd_imask;
+ 	}
+ 	return mine;
+ }
+ #endif
+ 
+ void
+ crossoutb(dev, ia, b)
+ 	struct device *dev;
+ 	int ia;
+ 	u_char b;
+ {
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 
+ #ifdef DEBUG
+ 	if (crossdebug)
+ 		printf("outb 0x%x,0x%x\n", ia, b);
+ #endif
+ 	
+ 	*(volatile u_char *)(cd->cd_zargs.va + 2 * ia) = b;
+ }
+ 
+ u_char
+ crossinb(dev, ia)
+ 	struct device *dev;
+ 	int ia;
+ {
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 
+ #ifdef DEBUG
+ 	u_char retval = *(volatile u_char *)(cd->cd_zargs.va + 2 * ia);
+ 
+ 	if (crossdebug)
+ 		printf("inb 0x%x => 0x%x\n", ia, retval);
+ 	return retval;
+ #else
+ 	return *(volatile u_char *)(cd->cd_zargs.va + 2 * ia);
+ #endif
+ }
+ 
+ void
+ crossoutw(dev, ia, w)
+ 	struct device *dev;
+ 	int ia;
+ 	u_short w;
+ {
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 
+ #ifdef DEBUG
+ 	if (crossdebug)
+ 		printf("outw 0x%x,0x%x\n", ia, w);
+ #endif
+ 	*(volatile u_short *)(cd->cd_zargs.va + 2 * ia) = w;
+ }
+ 
+ u_short
+ crossinw(dev, ia)
+ 	struct device *dev;
+ 	int ia;
+ {
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 	u_short retval = *(volatile u_short *)(cd->cd_zargs.va + 2 * ia);
+ 
+ #ifdef DEBUG
+ 	if (crossdebug)
+ 		printf("inw 0x%x => 0x%x\n", ia, retval);
+ #endif
+ 	return retval;
+ }
+ 
+ void
+ crossstb(dev, ia, b)
+ 	struct device *dev;
+ 	int ia;
+ 	u_char b;
+ {
+ 	/* generate A13-A19 for correct page */
+ 	u_short upper_addressbits = ia >> 13;
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 
+ 	*(volatile u_short *)(cd->cd_zargs.va + CROSS_XLP_LATCH) =
+ 	    upper_addressbits | CROSS_SBHE;
+ 	*(volatile u_char *)(cd->cd_zargs.va + CROSS_MEMORY_OFFSET + 2 * ia) =
+ 	    b;
+ }
+ 
+ u_char
+ crossldb(dev, ia)
+ 	struct device *dev;
+ 	int ia;
+ {
+ 	/* generate A13-A19 for correct page */
+ 	u_short upper_addressbits = ia >> 13;
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 
+ 	*(volatile u_short *)(cd->cd_zargs.va + CROSS_XLP_LATCH) =
+ 	    upper_addressbits | CROSS_SBHE;
+ 	return *(volatile u_char *)(cd->cd_zargs.va + CROSS_MEMORY_OFFSET +
+             2 * ia);
+ }
+ 
+ void
+ crossstw(dev, ia, w)
+ 	struct device *dev;
+ 	int ia;
+ 	u_short w;
+ {
+ 	/* generate A13-A19 for correct page */
+ 	u_short upper_addressbits = ia >> 13;
+ 	struct cross_device *cd = (struct cross_device *)dev;
+  	
+ 	*(volatile u_short *)(cd->cd_zargs.va + CROSS_XLP_LATCH) =
+ 	    upper_addressbits | CROSS_SBHE;
+ #ifdef DEBUG
+ 	if (crossdebug)
+ 		printf("outw 0x%x,0x%x\n", ia, w);
+ #endif
+ 	*(volatile u_short *)(cd->cd_zargs.va + CROSS_MEMORY_OFFSET + 2 * ia) =
+ 	    w;
+ }
+ 
+ u_short
+ crossldw(dev, ia)
+ 	struct device *dev;
+ 	int ia;
+ {
+ 	/* generate A13-A19 for correct page */
+ 	u_short upper_addressbits = ia >> 13;
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 	u_short retval;
+ 
+ 	*(volatile u_short *)(cd->cd_zargs.va + CROSS_XLP_LATCH) =
+ 	    upper_addressbits | CROSS_SBHE;
+ 	retval = *(volatile u_short *)(cd->cd_zargs.va + CROSS_MEMORY_OFFSET +
+ 	    2 * ia);
+ #ifdef DEBUG
+ 	if (crossdebug)
+ 		printf("ldw 0x%x => 0x%x\n", ia, retval);
+ #endif
+ 	return retval;
+ }
+ 
+ static cross_int_map[] = {
+     0, 0, 0, 0, CROSS_IRQ3, CROSS_IRQ4, CROSS_IRQ5, CROSS_IRQ6, CROSS_IRQ7, 0,
+     CROSS_IRQ9, CROSS_IRQ10, CROSS_IRQ11, CROSS_IRQ12, 0, CROSS_IRQ14,
+     CROSS_IRQ15
+ };
+ 
+ #if 0
+ /* XXX We don't care about the priority yet, although we ought to.  */
+ void
+ crossaddint(dev, irq, func, arg, pri)
+ 	struct device *dev;
+ 	int irq;
+ 	int (*func)();
+ 	void *arg;
+ 	int pri;
+ {
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 	int s = splhigh();
+ 	int bit = cross_int_map[irq + 1];
+ 
+ 	if (!bit) {
+ 		log(LOG_WARNING, "Registration of unknown ISA interrupt %d\n",
+ 		    irq);
+ 		goto out;
+ 	}
+ 	if (cd->cd_imask & 1 << bit) {
+ 		log(LOG_WARNING, "ISA interrupt %d already handled\n", irq);
+ 		goto out;
+ 	}
+ 	cd->cd_imask |= (1 << bit);
+         CROSS_ENABLE_INTS (cd->cd_zargs.va, cd->cd_imask);
+ 	cd->cd_ifunc[bit] = func;
+ 	cd->cd_ipri[bit] = pri;
+ 	cd->cd_iarg[bit] = arg;
+ out:
+ 	splx(s);
+ }
+ 
+ void
+ crossremint(dev, irq)
+ 	struct device *dev;
+ 	int irq;
+ {
+ 	struct cross_device *cd = (struct cross_device *)dev;
+ 	int s = splhigh();
+ 	int bit = cross_int_map[irq + 1];
+ 
+ 	cd->cd_imask &= ~(1 << bit);
+         CROSS_ENABLE_INTS (cd->cd_zargs.va, cd->cd_imask);
+ 	splx(s);
+ }
+ #else
+ struct crossintr_desc {
+ 	struct	isr cid_isr;
+ 	int	cid_mask;
+ 	struct	intrhand *cid_ih;
+ };
+ 
+ static struct crossintr_desc *crid[16];	/* XXX */
+ 
+ int
+ crossintr(cid)
+ 	struct crossintr_desc *cid;
+ {
+ 	return (CROSS_GET_STATUS (crossp->cd_zargs.va) & cid->cid_mask) ?
+ 	    (*cid->cid_ih->ih_fun)(cid->cid_ih->ih_arg) : 0;
+ }
+ 
+ void
+ crossaddint(irq, type, ih)
+ 	int irq;
+ 	int type;
+ 	struct intrhand *ih;
+ {
+ 	if (crid[irq]) {
+ 		log(LOG_WARNING, "ISA interrupt %d already handled\n", irq);
+ 		return;
+ 	}
+ 	MALLOC(crid[irq], struct crossintr_desc *,
+ 	    sizeof(struct crossintr_desc), M_DEVBUF, M_WAITOK);
+ 	crid[irq]->cid_isr.isr_intr = crossintr;
+ 	crid[irq]->cid_isr.isr_arg = crid[irq];
+ 	crid[irq]->cid_isr.isr_ipl = 6;
+ 	crid[irq]->cid_isr.isr_mapped_ipl = ih->ih_level;
+ 	crid[irq]->cid_mask = 1 << cross_int_map[irq + 1];
+ 	crid[irq]->cid_ih = ih;
+ 	add_isr (&crid[irq]->cid_isr);
+ 	crossp->cd_imask |= 1 << cross_int_map[irq + 1];
+         CROSS_ENABLE_INTS (crossp->cd_zargs.va, crossp->cd_imask);
+ }
+ 
+ void
+ crossremint(irq)
+ 	int irq;
+ {
+ 	remove_isr(&crid[irq]->cid_isr);
+ 	FREE(crid[irq], M_DEVBUF);
+ 	crid[irq] = 0;
+ 	crossp->cd_imask &= ~(1 << cross_int_map[irq + 1]);
+         CROSS_ENABLE_INTS (crossp->cd_zargs.va, crossp->cd_imask);
+ }
+ #endif
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/crossreg.h
***************
*** 0 ****
--- 1,133 ----
+ /*	$NetBSD: crossreg.h,v 1.1 1994/07/08 23:32:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1994 Niklas Hallqvist, Carsten Hammer
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Christian E. Hopps.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #ifndef _CROSSREG_H_
+ #define _CROSSREG_H_
+ /***
+ * 
+ *
+ * Hardware description:
+ *
+ *  The CrossLink board is a 64K autoconfig device. The board address can be
+ *  read from the xlink.resource structure instead of searching with the
+ *  expansion library. In this way, the manufacturer ID is not required by
+ *  the software developer.
+ *
+ *  Address mapping is as follows:
+ *   XL_ROM     16K of byte wide ROM appearing at even locations.
+ *              Used to hold the xlink.resource, and any autobooting
+ *              devices.
+ *   XL_MEM     Memory space. For 8 bit cards, bytes appear at even
+ *              locations, (ie multiply address by 2). For 16 bit cards,
+ *              words appear at long word boundaries (ie multiply by
+ *              2). You can read bytes from 16 bit cards - odd bytes
+ *              will appear at odd locations. SBHE must be set to the
+ *              appropriate value for this. Multiple pages are accessible
+ *              via the page register (see MemPage register).
+ *   XL_IO      I/O space. 8K of I/O space is supported by the hardware,
+ *              however only 1K is managed by this resource (as IBM's
+ *              *never* have cards which decode more I/O space than this).
+ *              You should AllocPortSpace() the area you want to use to
+ *              get exclusive access before using the I/O. 8/16 bit cards
+ *              read/write bytes/words at word boundaries. (You should know
+ *              whether the port is 8 or 16 bits wide).
+ *
+ * Within the 1K I/O space, there are some 8 and 16 bit registers on the
+ * xlink board itself. These registers are normally only accessed by
+ * the xlink.resource, they are only described here for completeness.
+ * Later revisions of the CrossLink board may move/change the meaning
+ * of these registers. They are as follows:
+ * (actual address = SBP_xxxx + SB_IO + board address)
+ *
+ *   XLP_LATCH  (Write Only) (offset = 2)
+ *              Latches most significant address lines. D0-D6 contain the
+ *              values for the most significant 7 address lines (A13-A19).
+ *              D7 contains data for SBHE line (always 1 for 8 bit transfers
+ *              on 8 bit boards, and 16 bit transfers on 16 bit boards.
+ *              Set SBHE to 0 to perform 8 bit transfers on 16 bit boards).
+ *
+ *   XLP_INTABLE (Write Only) (offset = 0)
+ *              Interrupt Enable & Disable. Bits map to the interrupts in
+ *              the following manner:
+ *                Data   Interrupt          Data   Interrupt
+ *                 2        10               10       2
+ *                 3        11               11       3
+ *                 4        12               12       4
+ *                 5        Master           13       5
+ *                 6        14               14       6
+ *                 7        15               15       7
+ *              Unused bits should not be interpreted in any way. When
+ *              writing to this register, unused bits should be zero. This
+ *              register should only be used by the xlink.resource.
+ *
+ *   XLP_INTSTAT (Read Only) (offset = 0)
+ *              Interrupt Status. Bit mapping is the same as the
+ *              XLP_INTABLE location. Normally you only need to add your
+ *              interrupt handler to the appropriate port, and not worry
+ *              about this register. However, it can be also used to
+ *              determine which interrupt a board is connected to. 
+ **/
+ /* hardware offsets from config address */
+ 
+ #define CROSS_XL_ROM          0x8000
+ #define CROSS_XL_MEM          0x4000
+ #define CROSS_XL_IO           0x0000
+ 
+ #define CROSS_XLP_INTSTAT 0
+ #define CROSS_XLP_INTABLE 0
+ #define CROSS_XLP_LATCH 2
+ 
+ #define CROSS_MEMORY_OFFSET (CROSS_XL_MEM - 2 * 0x90000)
+ #define CROSS_SBHE 0x40
+ 
+ #define CROSS_GET_STATUS(va) \
+     (*(volatile u_short *)((va) + CROSS_XLP_INTSTAT))
+ 
+ #define CROSS_MASTER 5
+ /* From what I understand IRQ2 is really IRQ9 -NH */
+ #define CROSS_IRQ9 10
+ #define CROSS_IRQ3 11
+ #define CROSS_IRQ4 12
+ #define CROSS_IRQ5 13
+ #define CROSS_IRQ6 14
+ #define CROSS_IRQ7 15
+ #define CROSS_IRQ10 2
+ #define CROSS_IRQ11 3
+ #define CROSS_IRQ12 4
+ #define CROSS_IRQ14 6
+ #define CROSS_IRQ15 7
+ #define CROSS_IRQMASK 0xfcdc
+ #define CROSS_GET_INT_STATUS(va) (CROSS_GET_STATUS(va) & CROSS_IRQMASK)
+ 
+ #define CROSS_ENABLE_INTS(va, ints) \
+     (*(volatile u_short *)((va) + CROSS_XLP_INTABLE) = ints) 
+ 
+ #endif
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/crossvar.h
***************
*** 0 ****
--- 1,46 ----
+ /*	$NetBSD: crossvar.h,v 1.1 1994/07/08 23:32:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1994 Niklas Hallqvist
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Christian E. Hopps.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #ifndef _CROSSVAR_H_
+ #define _CROSSVAR_H_
+ 
+ struct cross_device {
+ 	struct	device cd_dev;
+ 	struct	zbus_args cd_zargs;
+ 	struct	isa_link cd_link;
+ 	int	(*cd_ifunc[16])();
+ 	void	*cd_iarg[16];
+ 	int	cd_ipri[16];
+ 	int	cd_imask;
+ 	struct	isr cd_isr;
+ };
+ 
+ #endif
